diff -r f6ef988fda71 trytond/tests/test_fields.py
--- a/trytond/tests/test_fields.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/tests/test_fields.py	Sun Sep 23 17:30:03 2012 +0200
@@ -2519,149 +2385,140 @@
                                     }),
                             ],
                         })
-                self.assert_(one2many1_id)
-
-                one2many1 = one2many.read(one2many1_id, ['targets'])
-                self.assertEqual(len(one2many1['targets']), 1)
-                target1_id, = one2many1['targets']
+                self.assert_(one2many1)
+
+                self.assertEqual(len(one2many1.targets), 1)
+                target1, = one2many1.targets
 
                 # Try with target1 stored in cache
-                target1 = one2many_target.browse(target1_id)
+                target1 = one2many_target(target1.id)
                 target1.origin
-                one2many1 = one2many.read(one2many1_id, ['targets'])
-                self.assertEqual(one2many1['targets'], [target1_id])
-
-                one2many_ids = one2many.search([
+                one2many1 = one2many(one2many1)
+                self.assertEqual(one2many1.targets, (target1,))
+
+                one2manys = one2many.search([
                         ('targets', '=', 'target1'),
                         ])
-                self.assertEqual(one2many_ids, [one2many1_id])
-
-                one2many_ids = one2many.search([
+                self.assertEqual(one2manys, [one2many1])
+
+                one2manys = one2many.search([
                         ('targets', '!=', 'target1'),
                         ])
-                self.assertEqual(one2many_ids, [])
-
-                one2many_ids = one2many.search([
-                        ('targets', 'in', [target1_id]),
+                self.assertEqual(one2manys, [])
+
+                one2manys = one2many.search([
+                        ('targets', 'in', [target1.id]),
                         ])
-                self.assertEqual(one2many_ids, [one2many1_id])
-
-                one2many_ids = one2many.search([
+                self.assertEqual(one2manys, [one2many1])
+
+                one2manys = one2many.search([
                         ('targets', 'in', [0]),
                         ])
-                self.assertEqual(one2many_ids, [])
-
-                one2many_ids = one2many.search([
-                        ('targets', 'not in', [target1_id]),
+                self.assertEqual(one2manys, [])
+
+                one2manys = one2many.search([
+                        ('targets', 'not in', (target1.id,)),
                         ])
-                self.assertEqual(one2many_ids, [])
-
-                one2many_ids = one2many.search([
+                self.assertEqual(one2manys, [])
+
+                one2manys = one2many.search([
                         ('targets', 'not in', [0]),
                         ])
-                self.assertEqual(one2many_ids, [one2many1_id])
-
-                one2many_ids = one2many.search([
+                self.assertEqual(one2manys, [one2many1])
+
+                one2manys = one2many.search([
                         ('targets.name', '=', 'target1'),
                         ])
-                self.assertEqual(one2many_ids, [one2many1_id])
-
-                one2many_ids = one2many.search([
+                self.assertEqual(one2manys, [one2many1])
+
+                one2manys = one2many.search([
                         ('targets.name', '!=', 'target1'),
                         ])
-                self.assertEqual(one2many_ids, [])
-
-                one2many2_id = one2many.create({
+                self.assertEqual(one2manys, [])
+
+                one2many2 = one2many.create({
                         'name': 'origin2',
                         })
-                self.assert_(one2many2_id)
-
-                one2many2 = one2many.read(one2many2_id, ['targets'])
-                self.assertEqual(one2many2['targets'], [])
-
-                one2many_ids = one2many.search([
+                self.assert_(one2many2)
+
+                self.assertEqual(one2many2.targets, ())
+
+                one2manys = one2many.search([
                         ('targets', '=', None),
                         ])
-                self.assertEqual(one2many_ids, [one2many2_id])
-
-                one2many.write(one2many1_id, {
+                self.assertEqual(one2manys, [one2many2])
+
+                one2many.write([one2many1], {
                         'targets': [
-                            ('write', [target1_id], {
+                            ('write', [target1.id], {
                                     'name': 'target1bis',
                                     }),
                             ],
                         })
-                target1 = one2many_target.read(target1_id, ['name'])
-                self.assertEqual(target1['name'], 'target1bis')
-
-                target2_id = one2many_target.create({
+                self.assertEqual(target1.name, 'target1bis')
+
+                target2 = one2many_target.create({
                         'name': 'target2',
                         })
-                one2many.write(one2many1_id, {
+                one2many.write([one2many1], {
                         'targets': [
-                            ('add', [target2_id]),
+                            ('add', [target2.id]),
                             ],
                         })
-                one2many1 = one2many.read(one2many1_id, ['targets'])
-                self.assertEqual(one2many1['targets'],
-                    [target1_id, target2_id])
-
-                one2many.write(one2many1_id, {
+                self.assertEqual(one2many1.targets,
+                    (target1, target2))
+
+                one2many.write([one2many1], {
                         'targets': [
-                            ('unlink', [target2_id]),
+                            ('unlink', [target2.id]),
                             ],
                         })
-                one2many1 = one2many.read(one2many1_id, ['targets'])
-                self.assertEqual(one2many1['targets'], [target1_id])
-                target2_id, = one2many_target.search([
-                        ('id', '=', target2_id),
+                self.assertEqual(one2many1.targets, (target1,))
+                target2, = one2many_target.search([
+                        ('id', '=', target2.id),
                         ])
-                self.assert_(target2_id)
-
-                one2many.write(one2many1_id, {
+                self.assert_(target2)
+
+                one2many.write([one2many1], {
                         'targets': [
                             ('unlink_all',),
                             ],
                         })
-                one2many1 = one2many.read(one2many1_id, ['targets'])
-                self.assertEqual(one2many1['targets'], [])
-                target_ids = one2many_target.search([
-                        ('id', 'in', [target1_id, target2_id]),
+                self.assertEqual(one2many1.targets, ())
+                targets = one2many_target.search([
+                        ('id', 'in', [target1.id, target2.id]),
                         ])
-                self.assertEqual(target_ids, [target1_id, target2_id])
-
-                one2many.write(one2many1_id, {
+                self.assertEqual(targets, [target1, target2])
+
+                one2many.write([one2many1], {
                         'targets': [
-                            ('set', [target1_id, target2_id]),
+                            ('set', [target1.id, target2.id]),
                             ],
                         })
-                one2many1 = one2many.read(one2many1_id, ['targets'])
-                self.assertEqual(one2many1['targets'],
-                    [target1_id, target2_id])
-
-                one2many.write(one2many1_id, {
+                self.assertEqual(one2many1.targets,
+                    (target1, target2))
+
+                one2many.write([one2many1], {
                         'targets': [
-                            ('delete', [target2_id]),
+                            ('delete', [target2.id]),
                             ],
                         })
-                one2many1 = one2many.read(one2many1_id, ['targets'])
-                self.assertEqual(one2many1['targets'], [target1_id])
-                target_ids = one2many_target.search([
-                        ('id', '=', target2_id),
+                self.assertEqual(one2many1.targets, (target1,))
+                targets = one2many_target.search([
+                        ('id', '=', target2.id),
                         ])
-                self.assertEqual(target_ids, [])
-
-                one2many.write(one2many1_id, {
+                self.assertEqual(targets, [])
+
+                one2many.write([one2many1], {
                         'targets': [
                             ('delete_all',),
                             ],
                         })
-                one2many1 = one2many.read(one2many1_id, ['targets'])
-                self.assertEqual(one2many1['targets'], [])
-                target_ids = one2many_target.search([
-                        ('id', '=', target1_id),
+                self.assertEqual(one2many1.targets, ())
+                targets = one2many_target.search([
+                        ('id', '=', target1.id),
                         ])
-                self.assertEqual(target_ids, [])
+                self.assertEqual(targets, [])
 
                 transaction.cursor.rollback()
 
@@ -2708,7 +2565,7 @@
                     (self.many2many_reference,
                         self.many2many_reference_target),
                     ):
-                many2many1_id = many2many.create({
+                many2many1 = many2many.create({
                         'name': 'origin1',
                         'targets': [
                             ('create', {
@@ -2716,143 +2573,134 @@
                                     }),
                             ],
                         })
-                self.assert_(many2many1_id)
-
-                many2many1 = many2many.read(many2many1_id, ['targets'])
-                self.assertEqual(len(many2many1['targets']), 1)
-                target1_id, = many2many1['targets']
-
-                many2many_ids = many2many.search([
+                self.assert_(many2many1)
+
+                self.assertEqual(len(many2many1.targets), 1)
+                target1, = many2many1.targets
+
+                many2manys = many2many.search([
                         ('targets', '=', 'target1'),
                         ])
-                self.assertEqual(many2many_ids, [many2many1_id])
-
-                many2many_ids = many2many.search([
+                self.assertEqual(many2manys, [many2many1])
+
+                many2manys = many2many.search([
                         ('targets', '!=', 'target1'),
                         ])
-                self.assertEqual(many2many_ids, [])
-
-                many2many_ids = many2many.search([
-                        ('targets', 'in', [target1_id]),
+                self.assertEqual(many2manys, [])
+
+                many2manys = many2many.search([
+                        ('targets', 'in', [target1.id]),
                         ])
-                self.assertEqual(many2many_ids, [many2many1_id])
-
-                many2many_ids = many2many.search([
+                self.assertEqual(many2manys, [many2many1])
+
+                many2manys = many2many.search([
                         ('targets', 'in', [0]),
                         ])
-                self.assertEqual(many2many_ids, [])
-
-                many2many_ids = many2many.search([
-                        ('targets', 'not in', [target1_id]),
+                self.assertEqual(many2manys, [])
+
+                many2manys = many2many.search([
+                        ('targets', 'not in', [target1.id]),
                         ])
-                self.assertEqual(many2many_ids, [])
-
-                many2many_ids = many2many.search([
+                self.assertEqual(many2manys, [])
+
+                many2manys = many2many.search([
                         ('targets', 'not in', [0]),
                         ])
-                self.assertEqual(many2many_ids, [many2many1_id])
-
-                many2many_ids = many2many.search([
+                self.assertEqual(many2manys, [many2many1])
+
+                many2manys = many2many.search([
                         ('targets.name', '=', 'target1'),
                         ])
-                self.assertEqual(many2many_ids, [many2many1_id])
-
-                many2many_ids = many2many.search([
+                self.assertEqual(many2manys, [many2many1])
+
+                many2manys = many2many.search([
                         ('targets.name', '!=', 'target1'),
                         ])
-                self.assertEqual(many2many_ids, [])
-
-                many2many2_id = many2many.create({
+                self.assertEqual(many2manys, [])
+
+                many2many2 = many2many.create({
                         'name': 'origin2',
                         })
-                self.assert_(many2many2_id)
-
-                many2many2 = many2many.read(many2many2_id, ['targets'])
-                self.assertEqual(many2many2['targets'], [])
-
-                many2many_ids = many2many.search([
+                self.assert_(many2many2)
+
+                self.assertEqual(many2many2.targets, ())
+
+                many2manys = many2many.search([
                         ('targets', '=', None),
                         ])
-                self.assertEqual(many2many_ids, [many2many2_id])
-
-                many2many.write(many2many1_id, {
+                self.assertEqual(many2manys, [many2many2])
+
+                many2many.write([many2many1], {
                         'targets': [
-                            ('write', [target1_id], {
+                            ('write', [target1.id], {
                                     'name': 'target1bis',
                                     }),
                             ],
                         })
-                target1 = many2many_target.read(target1_id, ['name'])
-                self.assertEqual(target1['name'], 'target1bis')
-
-                target2_id = many2many_target.create({
+                self.assertEqual(target1.name, 'target1bis')
+
+                target2 = many2many_target.create({
                         'name': 'target2',
                         })
-                many2many.write(many2many1_id, {
+                many2many.write([many2many1], {
                         'targets': [
-                            ('add', [target2_id]),
+                            ('add', [target2.id]),
                             ],
                         })
-                many2many1 = many2many.read(many2many1_id, ['targets'])
-                self.assertEqual(many2many1['targets'],
-                    [target1_id, target2_id])
-
-                many2many.write(many2many1_id, {
+                self.assertEqual(many2many1.targets,
+                    (target1, target2))
+
+                many2many.write([many2many1], {
                         'targets': [
-                            ('unlink', [target2_id]),
+                            ('unlink', [target2.id]),
                             ],
                         })
-                many2many1 = many2many.read(many2many1_id, ['targets'])
-                self.assertEqual(many2many1['targets'], [target1_id])
-                target2_id, = many2many_target.search([
-                        ('id', '=', target2_id),
+                self.assertEqual(many2many1.targets, (target1,))
+                target2, = many2many_target.search([
+                        ('id', '=', target2.id),
                         ])
-                self.assert_(target2_id)
-
-                many2many.write(many2many1_id, {
+                self.assert_(target2)
+
+                many2many.write([many2many1], {
                         'targets': [
                             ('unlink_all',),
                             ],
                         })
-                many2many1 = many2many.read(many2many1_id, ['targets'])
-                self.assertEqual(many2many1['targets'], [])
-                target_ids = many2many_target.search([
-                        ('id', 'in', [target1_id, target2_id]),
+                self.assertEqual(many2many1.targets, ())
+                targets = many2many_target.search([
+                        ('id', 'in', [target1.id, target2.id]),
                         ])
-                self.assertEqual(target_ids, [target1_id, target2_id])
-
-                many2many.write(many2many1_id, {
+                self.assertEqual(targets, [target1, target2])
+
+                many2many.write([many2many1], {
                         'targets': [
-                            ('set', [target1_id, target2_id]),
+                            ('set', [target1.id, target2.id]),
                             ],
                         })
-                many2many1 = many2many.read(many2many1_id, ['targets'])
-                self.assertEqual(many2many1['targets'],
-                    [target1_id, target2_id])
-
-                many2many.write(many2many1_id, {
+                self.assertEqual(many2many1.targets,
+                    (target1, target2))
+
+                many2many.write([many2many1], {
                         'targets': [
-                            ('delete', [target2_id]),
+                            ('delete', [target2.id]),
                             ],
                         })
-                many2many1 = many2many.read(many2many1_id, ['targets'])
-                self.assertEqual(many2many1['targets'], [target1_id])
-                target_ids = many2many_target.search([
-                        ('id', '=', target2_id),
+                self.assertEqual(many2many1.targets, (target1,))
+                targets = many2many_target.search([
+                        ('id', '=', target2.id),
                         ])
-                self.assertEqual(target_ids, [])
-
-                many2many.write(many2many1_id, {
+                self.assertEqual(targets, [])
+
+                many2many.write([many2many1], {
                         'targets': [
                             ('delete_all',),
                             ],
                         })
-                many2many1 = many2many.read(many2many1_id, ['targets'])
-                self.assertEqual(many2many1['targets'], [])
-                target_ids = many2many_target.search([
-                        ('id', '=', target1_id),
+                self.assertEqual(many2many1.targets, ())
+                targets = many2many_target.search([
+                        ('id', '=', target1.id),
                         ])
-                self.assertEqual(target_ids, [])
+                self.assertEqual(targets, [])
 
                 transaction.cursor.rollback()
 
@@ -2891,140 +2739,125 @@
         '''
         with Transaction().start(DB_NAME, USER,
                 context=CONTEXT) as transaction:
-            target1_id = self.reference_target.create({
+            target1 = self.reference_target.create({
                     'name': 'target1',
                     })
-            reference1_id = self.reference.create({
+            reference1 = self.reference.create({
                     'name': 'reference1',
-                    'reference': 'test.reference.target,%s' % target1_id,
+                    'reference': str(target1),
                     })
-            self.assert_(reference1_id)
-
-            reference1 = self.reference.read(reference1_id, ['reference'])
-            self.assertEqual(reference1['reference'],
-                'test.reference.target,%s' % target1_id)
-
-            reference_ids = self.reference.search([
-                    ('reference', '=',
-                        'test.reference.target,%s' % target1_id),
+            self.assert_(reference1)
+
+            self.assertEqual(reference1.reference, target1)
+
+            references = self.reference.search([
+                    ('reference', '=', str(target1)),
                     ])
-            self.assertEqual(reference_ids, [reference1_id])
-
-            reference_ids = self.reference.search([
-                    ('reference', '=',
-                        ('test.reference.target', target1_id)),
+            self.assertEqual(references, [reference1])
+
+            references = self.reference.search([
+                    ('reference', '=', str(target1)),
                     ])
-            self.assertEqual(reference_ids, [reference1_id])
-
-            reference_ids = self.reference.search([
-                    ('reference', '=',
-                        ['test.reference.target', target1_id]),
+            self.assertEqual(references, [reference1])
+
+            references = self.reference.search([
+                    ('reference', '=', str(target1)),
                     ])
-            self.assertEqual(reference_ids, [reference1_id])
-
-            reference_ids = self.reference.search([
-                    ('reference', '!=',
-                        'test.reference.target,%s' % target1_id),
+            self.assertEqual(references, [reference1])
+
+            references = self.reference.search([
+                    ('reference', '!=', str(target1)),
                     ])
-            self.assertEqual(reference_ids, [])
-
-            reference_ids = self.reference.search([
-                    ('reference', '!=',
-                        ('test.reference.target', target1_id)),
+            self.assertEqual(references, [])
+
+            references = self.reference.search([
+                    ('reference', '!=', str(target1)),
                     ])
-            self.assertEqual(reference_ids, [])
-
-            reference_ids = self.reference.search([
+            self.assertEqual(references, [])
+
+            references = self.reference.search([
+                    ('reference', 'in', [str(target1)]),
+                    ])
+            self.assertEqual(references, [reference1])
+
+            references = self.reference.search([
                     ('reference', 'in',
-                        ['test.reference.target,%s' % target1_id]),
+                        [('test.reference.target', target1.id)]),
                     ])
-            self.assertEqual(reference_ids, [reference1_id])
-
-            reference_ids = self.reference.search([
-                    ('reference', 'in',
-                        [('test.reference.target', target1_id)]),
-                    ])
-            self.assertEqual(reference_ids, [reference1_id])
-
-            reference_ids = self.reference.search([
+            self.assertEqual(references, [reference1])
+
+            references = self.reference.search([
                     ('reference', 'in', [None]),
                     ])
-            self.assertEqual(reference_ids, [])
-
-            reference_ids = self.reference.search([
+            self.assertEqual(references, [])
+
+            references = self.reference.search([
+                    ('reference', 'not in', [str(target1)]),
+                    ])
+            self.assertEqual(references, [])
+
+            references = self.reference.search([
                     ('reference', 'not in',
-                        ['test.reference.target,%s' % target1_id]),
+                        [('test.reference.target', target1.id)]),
                     ])
-            self.assertEqual(reference_ids, [])
-
-            reference_ids = self.reference.search([
-                    ('reference', 'not in',
-                        [('test.reference.target', target1_id)]),
-                    ])
-            self.assertEqual(reference_ids, [])
-
-            reference_ids = self.reference.search([
+            self.assertEqual(references, [])
+
+            references = self.reference.search([
                     ('reference', 'not in', [None]),
                     ])
-            self.assertEqual(reference_ids, [reference1_id])
-
-            reference2_id = self.reference.create({
+            self.assertEqual(references, [reference1])
+
+            reference2 = self.reference.create({
                     'name': 'reference2',
                     })
-            self.assert_(reference2_id)
-
-            reference2 = self.reference.read(reference2_id, ['reference'])
-            self.assertEqual(reference2['reference'], None)
-
-            reference_ids = self.reference.search([
+            self.assert_(reference2)
+
+            self.assertEqual(reference2.reference, None)
+
+            references = self.reference.search([
                     ('reference', '=', None),
                     ])
-            self.assertEqual(reference_ids, [reference2_id])
-
-            target2_id = self.reference_target.create({
+            self.assertEqual(references, [reference2])
+
+            target2 = self.reference_target.create({
                     'name': 'target2',
                     })
 
-            self.reference.write(reference2_id, {
-                    'reference': 'test.reference.target,%s' % target2_id,
+            self.reference.write([reference2], {
+                    'reference': str(target2),
                     })
-            reference2 = self.reference.read(reference2_id, ['reference'])
-            self.assertEqual(reference2['reference'],
-                'test.reference.target,%s' % target2_id)
-
-            self.reference.write(reference2_id, {
+            self.assertEqual(reference2.reference, target2)
+
+            self.reference.write([reference2], {
                     'reference': None,
                     })
-            reference2 = self.reference.read(reference2_id, ['reference'])
-            self.assertEqual(reference2['reference'], None)
-
-            self.reference.write(reference2_id, {
-                    'reference': ('test.reference.target', target2_id),
+            self.assertEqual(reference2.reference, None)
+
+            self.reference.write([reference2], {
+                    'reference': ('test.reference.target', target2.id),
                     })
-            reference2 = self.reference.read(reference2_id, ['reference'])
-            self.assertEqual(reference2['reference'],
-                'test.reference.target,%s' % target2_id)
-
-            reference3_id = self.reference.create({
+            self.assertEqual(reference2.reference, target2)
+
+            reference3 = self.reference.create({
                     'name': 'reference3',
-                    'reference': ('test.reference.target', target1_id),
+                    'reference': ('test.reference.target', target1.id),
                     })
-            self.assert_(reference3_id)
+            self.assert_(reference3)
 
             self.assertRaises(Exception, self.reference_required.create, {
                     'name': 'reference4',
                     })
             transaction.cursor.rollback()
 
-            target4_id = self.reference_target.create({
+            target4 = self.reference_target.create({
                     'name': 'target4_id',
                     })
 
-            reference4_id = self.reference_required.create({
+            reference4 = self.reference_required.create({
                     'name': 'reference4',
-                    'reference': 'test.reference.target,%s' % target4_id,
+                    'reference': str(target4),
                     })
-            self.assert_(reference4_id)
+            self.assert_(reference4)
 
             transaction.cursor.rollback()
 
